// This is a scripted coppercube action. Toggles fullscreen mode in WebGL target.
// Note: In Chrome and Firefox this needs to be run from a click or key event; in IE it needs to be run from a click event.
// At the moment this action does not work in flash.
//
/*
    <action jsname="action_ToggleFullscreen" description="Toggle fullscreen in WebGL">
        <property name="EnableMouseLock" type="bool" default="true" />
        <property name="UseFullscreenResolution" type="bool" default="true" />
    </action>
*/

(function () {    // Set everything up with an anonymous function
    'use strict';
    ccbSwitchToFullscreen.canvas = document.querySelectorAll('canvas')[0];    // Get the canvas (or our best guess!)
    if (ccbSwitchToFullscreen.canvas) {
        ccbSwitchToFullscreen.originalWidth = ccbSwitchToFullscreen.canvas.width;    // Remember original resolution
        ccbSwitchToFullscreen.originalHeight = ccbSwitchToFullscreen.canvas.height;
    }
    if (document.webkitFullscreenEnabled) {    // If WebKit, create and apply the fullscreen style shim.
        var webkitFullscreenStyle = document.createElement('style');
        webkitFullscreenStyle.innerHTML = ':-webkit-full-screen {\n ' +
                'position: fixed;\n left: 0px;\n top: 0px;\n margin: 0px;\n height: 100%;\n width: 100%;\n display: block\n}';
        document.head.appendChild(webkitFullscreenStyle);
    }
    function setResolution() {    // When fullscreen state changes, this function changes the resolution if required.
        if (ccbSwitchToFullscreen.useFullscreenResolution &&
                (document.fullscreenElement || document.mozFullScreenElement || document.webkitFullscreenElement || document.msFullscreenElement)) {
            ccbSwitchToFullscreen.canvas.width = window.screen.width;
            ccbSwitchToFullscreen.canvas.height = window.screen.height;
        } else if (ccbSwitchToFullscreen.useFullscreenResolution) {
            ccbSwitchToFullscreen.canvas.width = ccbSwitchToFullscreen.originalWidth;
            ccbSwitchToFullscreen.canvas.height = ccbSwitchToFullscreen.originalHeight;
        }
    }
    document.addEventListener('fullscreenchange', setResolution);
    document.addEventListener('webkitfullscreenchange', setResolution);
    document.addEventListener('mozfullscreenchange', setResolution);
    document.addEventListener('MSFullscreenChange', setResolution);
}());

action_ToggleFullscreen = function () {
    'use strict';
};

// called when the action is executed 
action_ToggleFullscreen.prototype.execute = function () {
    'use strict';
    ccbSwitchToFullscreen.useFullscreenResolution = this.UseFullscreenResolution;
    if (document.fullscreenElement) {
        document.exitFullscreen();
    } else if (document.mozFullScreenElement) {
        document.mozCancelFullScreen();
    } else if (document.webkitFullscreenElement) {
        document.webkitExitFullscreen();
    } else if (document.msFullscreenElement) {
        document.msExitFullscreen();
    } else {
        ccbSwitchToFullscreen(this.EnableMouseLock);
    }
};